# This file was auto-generated by Fern from our API Definition.

import datetime as dt
import typing

import pydantic.v1 as pydantic

from ...core.datetime_utils import serialize_datetime


class RegisterDatasetSchema(pydantic.BaseModel):
    """
    Examples
    --------
    from sphinxbio import RegisterDatasetSchema

    RegisterDatasetSchema(
        class_name="AminoAcidSequence",
        cloud_pickle="gANjX19wcm9wZXJ0aWVzX18KcHJvcGVydGllcwoxLg==",
    )
    """

    class_name: str = pydantic.Field(alias="className")
    cloud_pickle: str = pydantic.Field(alias="cloudPickle")

    def json(self, **kwargs: typing.Any) -> str:
        kwargs_with_defaults: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        return super().json(**kwargs_with_defaults)

    def dict(self, **kwargs: typing.Any) -> typing.Dict[str, typing.Any]:
        kwargs_with_defaults: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        return super().dict(**kwargs_with_defaults)

    class Config:
        frozen = True
        smart_union = True
        allow_population_by_field_name = True
        populate_by_name = True
        extra = pydantic.Extra.allow
        json_encoders = {dt.datetime: serialize_datetime}
