# This file was auto-generated by Fern from our API Definition.

import datetime as dt
import typing

import pydantic.v1 as pydantic

from ...core.datetime_utils import serialize_datetime
from ...pagination.types.paginated_response import PaginatedResponse
from ...shared.entity.types.entity import Entity


class PaginatedEntities(PaginatedResponse):
    """
    Examples
    --------
    import datetime

    from sphinxbio import PaginatedEntities
    from sphinxbio.shared import Creator, Entity_AaSequence

    PaginatedEntities(
        data=[
            Entity_AaSequence(
                id="seq_12345",
                campaign_id="camp_67890",
                creator=Creator(
                    id="user_123",
                    email="researcher@example.com",
                ),
                created_at=datetime.datetime.fromisoformat(
                    "2023-01-01 00:00:00+00:00",
                ),
                updated_at=datetime.datetime.fromisoformat(
                    "2023-01-02 00:00:00+00:00",
                ),
                name="Hemoglobin Subunit Beta",
                amino_acids="MVHLTPEEKSAVTALWGKVNVDEVGGEALGRLLVVYPWTQRFFESFGDLSTPDAVMGNPKVKAHGKKVLGAFSDGLAHLDNLKGTFATLSELHCDKLHVDPENFRLLGNVLVCVLAHHFGKEFTPPVQAAYQKVVAGVANALAHKYH",
                is_control=False,
            )
        ],
        next_token="bmV4dF90b2tlbl9mb3JfZW50aXRpZXM=",
        url="https://api.sphinxbio.com/v1/entities",
    )
    """

    data: typing.List[Entity]

    def json(self, **kwargs: typing.Any) -> str:
        kwargs_with_defaults: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        return super().json(**kwargs_with_defaults)

    def dict(self, **kwargs: typing.Any) -> typing.Dict[str, typing.Any]:
        kwargs_with_defaults: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        return super().dict(**kwargs_with_defaults)

    class Config:
        frozen = True
        smart_union = True
        allow_population_by_field_name = True
        populate_by_name = True
        extra = pydantic.Extra.allow
        json_encoders = {dt.datetime: serialize_datetime}
